<template>
  <div>
    <DxDataGrid
        :data-source="tableData"
        :allow-column-reordering="true"

    >
      <DxExport :enabled="true" />
      <DxColumn data-field="id" :width="130"/>
      <DxColumn data-field="title"/>
      <DxColumn data-field="rand"/>
      <DxPaging :page-size="rowPerPage"/>
      <DxPager
          :visible="true"
          :allowed-page-sizes="[]"
          :display-mode="'full'"
          :show-page-size-selector="true"
          :show-info="true"
          :show-navigation-buttons="true"
      />
    </DxDataGrid>
  </div>
</template>

<script>
import {
  DxDataGrid, DxColumn, DxPaging, DxPager, DxExport
} from 'devextreme-vue/data-grid';
import { Workbook } from 'exceljs';
import saveAs from 'file-saver';
import { exportDataGrid } from 'devextreme/excel_exporter';

export default {
  name: "Table",
  components: {
    DxDataGrid,
    DxColumn,
    DxPaging,
    DxPager,
    DxExport
  },
  props: {
    tableData: {
      required: true,
      type: Array,
      default: () => ([])
    },
    rowPerPage: {
      required: true,
      type: Number,
      default: 0,
    },
    methods: {
      exportGrid(e) {
        console.log(e);
        const workbook = new Workbook();
        const worksheet = workbook.addWorksheet('Sales');
        exportDataGrid({
          worksheet: worksheet,
          component: e.component
        }).then(function() {
          workbook.xlsx.writeBuffer().then(function(buffer) {
            saveAs(new Blob([buffer], { type: "application/octet-stream" }), "Sales.xlsx");
          });
        });
        e.cancel = true;
      }
    }
  }

}
</script>

<style scoped>

</style>
